#ifndef SCEENTEST_H
#define SCEENTEST_H
#include <QObject>
#include "fullinterface.h"
class Pixmap : public QGraphicsWidget
{
    Q_OBJECT

public:
    Pixmap(const QPixmap &pix, QGraphicsItem *parent = 0)
        : QGraphicsWidget(parent), orig(pix), p(pix)
    {

        setCacheMode(DeviceCoordinateCache);
        setAcceptHoverEvents(true);
    }


    void paint(QPainter *painter, const QStyleOptionGraphicsItem *, QWidget *)
    {
        painter->drawPixmap(QPointF(), p);
    }

    virtual void setGeometry(const QRectF &rect)
    {
        QGraphicsWidget::setGeometry(rect);
   p = orig.scaled(rect.size().toSize());
//        if (rect.size().width() > orig.size().width())
//            p = orig.scaled(rect.size().toSize());
//        else
//            p = orig;
    }
    virtual void setPixmap(QPixmap pix)

    {

             orig=pix;
    }
 public slots:
    void setHide()
    {
     //   QGraphicsWidget::hide();
        QGraphicsWidget::setOpacity(0);
    }

signals:
    void pressed();
    void release();
    void enter();
    void leave();
 void mouseMove();

protected:

    void mousePressEvent(QGraphicsSceneMouseEvent *)
    {
        emit pressed();
        update();
    }
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *)
    {
        emit release();
        update();
    }
    void hoverEnterEvent(  QGraphicsSceneHoverEvent *)
    {

        emit enter();
        update();

    }
    void hoverLeaveEvent ( QGraphicsSceneHoverEvent  *)
    {
        emit leave();
        update();
    }
        void mouseMoveEvent(QGraphicsSceneMouseEvent *)
        {
            emit mouseMove();
            update();
        }

private:
    QPixmap orig;
    QPixmap p;

};


 class SceenFull : public QGraphicsScene, SceenFullInterface
 {
     Q_OBJECT
     Q_INTERFACES(SceenFullInterface)
 public:
     SceenFull();
     ~SceenFull();

 public slots:

     void  setPixmapAya(QPixmap pix);//تحديد الاية
     void setInfo(QString sura,QString  jozaa,QString hizb,QString rbaa,QString aya,QString reciter,QString trans);
     void setAnimationEnabled(bool enable);
     void execOptions();
     void setGraphicSceen(QGraphicsView *view);

 private slots:

     void createSceen();

     void createTopPanel();
     void creatBotPanel();
     void creatItemAnim();

     void setBackground();

     void stopAnimation();//ايقاف الحركات
     void animAya();
 void animAqua(int index);
  void animRain(int index,int x,int y);
     void loadSetting();
     void saveSetting();
      void setAnim0();
       void setAnim1();
         void setAnim2();
 private:
     static const int NumIndex=3 ;
     QGraphicsScene * sceen ;
     QGraphicsPixmapItem *pageAya;//محتوى الاية
     QGraphicsPixmapItem *pixBgr;//محتوى صورة الخلفية
     QGraphicsPixmapItem *pixBgrBack;
      QGraphicsWidget *panelReflect;//محتوى صورة الزخرفة السفلى
     QGraphicsWidget *zekhrafaRondedTop;//محتوى صورة الزخرفة العليا
     QGraphicsWidget *panelAya ;//محتوى اطار الاية
     QGraphicsPixmapItem *itemAya;//الاطار الذي سيرسم عليه الاطار الابيض
     QGraphicsWidget  *itemBlurAya ;
     QGraphicsWidget  *itemBlurTop ;

     QParallelAnimationGroup *group;

     QLabel *labelInfo;
     QLabel *labelTrans;
     QString  appPath;
     QString m_fullbackground;


            Pixmap *myRain[NumIndex];
            Pixmap *myref[NumIndex];
            Pixmap *myref2[NumIndex];
             Pixmap *myref3[NumIndex];
             QTimer *timer0;
             QTimer *timer1;
               QTimer *timer2;
             int curIndex;
 };

#endif // SCEENTEST_H
